//----------M.c lib3D_MEC expoted-----------

//For increased velocity use GSL HAVE_INLINE and GSL_RANGE_CHECK_OFF preprocesor directive to compile:

// gcc -DHAVE_INLINE = 1 -DGSL_RANGE_CHECK_OFF = 1 ... ---

#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include "var_def.h"
#include "gen_coord_vect_def.h"
#include "gen_vel_vect_def.h"
#include "gen_accel_vect_def.h"
#include "unknowns_vect_def.h"
#include <math.h>
#define theta1 gsl_vector_get ( q , 0 )
#define theta2 gsl_vector_get ( q , 1 )
#define dtheta1 gsl_vector_get ( dq , 0 )
#define dtheta2 gsl_vector_get ( dq , 1 )
#define ddtheta1 gsl_vector_get ( ddq , 0 )
#define ddtheta2 gsl_vector_get ( ddq , 1 )
#define Fgp12 gsl_vector_get ( unknowns , 0 )
#define Fgp13 gsl_vector_get ( unknowns , 1 )
#define Fp1p22 gsl_vector_get ( unknowns , 2 )
#define Fp1p23 gsl_vector_get ( unknowns , 3 )
extern double atom5;
extern double atom7;
extern double atom8;
extern double atom9;
extern double atom10;
extern double atom41;
extern double atom43;
extern double atom51;
extern double atom52;
extern double atom53;
extern double atom54;
extern double atom55;
extern double atom56;
extern double atom83;
extern double atom74;
extern double atom76;
extern double atom84;
extern double atom75;
extern double atom77;
extern double atom85;
extern double atom86;
gsl_matrix * J = NULL;
gsl_matrix * M ()
{
size_t n_rows = 2;
size_t n_cols = 2;
if ( J == NULL )
 {
    J = gsl_matrix_alloc ( n_rows , n_cols );
    gsl_matrix_set_zero ( J );
 }
gsl_matrix_set ( J , 0 , 0 , atom83 );
gsl_matrix_set ( J , 0 , 1 , atom84 );
gsl_matrix_set ( J , 1 , 0 , atom85 );
gsl_matrix_set ( J , 1 , 1 , atom86 );
return J;
}
