//----------MV.c lib3D_MEC expoted-----------

//For increased velocity use GSL HAVE_INLINE and GSL_RANGE_CHECK_OFF preprocesor directive to compile:

// gcc -DHAVE_INLINE = 1 -DGSL_RANGE_CHECK_OFF = 1 ... ---

#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include "var_def.h"
#include "gen_coord_vect_def.h"
#include "gen_vel_vect_def.h"
#include "gen_accel_vect_def.h"
#include "unknowns_vect_def.h"
#include <math.h>
#define theta1 gsl_vector_get ( q , 0 )
#define theta2 gsl_vector_get ( q , 1 )
#define dtheta1 gsl_vector_get ( dq , 0 )
#define dtheta2 gsl_vector_get ( dq , 1 )
#define ddtheta1 gsl_vector_get ( ddq , 0 )
#define ddtheta2 gsl_vector_get ( ddq , 1 )
#define Fgp12 gsl_vector_get ( unknowns , 0 )
#define Fgp13 gsl_vector_get ( unknowns , 1 )
#define Fp1p22 gsl_vector_get ( unknowns , 2 )
#define Fp1p23 gsl_vector_get ( unknowns , 3 )
extern double atom96;
extern double atom59;
extern double atom60;
extern double atom61;
extern double atom62;
extern double atom63;
extern double atom64;
extern double atom97;
extern double atom102;
extern double atom103;
extern double atom41;
extern double atom43;
extern double atom5;
extern double atom7;
extern double atom8;
extern double atom9;
extern double atom10;
extern double atom98;
extern double atom99;
extern double atom100;
extern double atom101;
gsl_matrix * J = NULL;
gsl_matrix * MV ()
{
size_t n_rows = 6;
size_t n_cols = 6;
if ( J == NULL )
 {
    J = gsl_matrix_alloc ( n_rows , n_cols );
    gsl_matrix_set_zero ( J );
gsl_matrix_set ( J , 0 , 1 , 0.0 );
gsl_matrix_set ( J , 1 , 1 , 0.0 );
gsl_matrix_set ( J , 2 , 0 , -I1 );
gsl_matrix_set ( J , 2 , 1 , 0.0 );
gsl_matrix_set ( J , 2 , 2 , (1.0/2.0)*l1 );
gsl_matrix_set ( J , 2 , 3 , 0.0 );
gsl_matrix_set ( J , 3 , 2 , 0.0 );
gsl_matrix_set ( J , 3 , 3 , 0.0 );
gsl_matrix_set ( J , 4 , 2 , 0.0 );
gsl_matrix_set ( J , 4 , 3 , 0.0 );
gsl_matrix_set ( J , 5 , 0 , -I2 );
gsl_matrix_set ( J , 5 , 1 , -I2 );
gsl_matrix_set ( J , 5 , 2 , 0.0 );
gsl_matrix_set ( J , 5 , 3 , 0.0 );
gsl_matrix_set ( J , 5 , 4 , (1.0/2.0)*l2 );
gsl_matrix_set ( J , 5 , 5 , 0.0 );
 }
 atom96 = (1.0/2.0)*atom41*mpendulum1*l1;
 atom59 = atom5*atom41;
 atom60 = -atom7*atom43;
 atom61 = atom60+atom59;
 atom62 = -atom5*atom43;
 atom63 = -atom41*atom7;
 atom64 = atom63+atom62;
 atom97 = (1.0/2.0)*mpendulum1*atom43*l1;
 atom102 = (1.0/2.0)*atom5*l1;
 atom103 = -(1.0/2.0)*atom7*l1;
gsl_matrix_set ( J , 0 , 0 , atom96 );
gsl_matrix_set ( J , 0 , 2 , atom41 );
gsl_matrix_set ( J , 0 , 3 , -atom43 );
gsl_matrix_set ( J , 0 , 4 , -atom61 );
gsl_matrix_set ( J , 0 , 5 , -atom64 );
gsl_matrix_set ( J , 1 , 0 , atom97 );
gsl_matrix_set ( J , 1 , 2 , atom43 );
gsl_matrix_set ( J , 1 , 3 , atom41 );
gsl_matrix_set ( J , 1 , 4 , atom64 );
gsl_matrix_set ( J , 1 , 5 , -atom61 );
gsl_matrix_set ( J , 2 , 4 , atom102 );
gsl_matrix_set ( J , 2 , 5 , atom103 );
gsl_matrix_set ( J , 3 , 0 , atom98 );
gsl_matrix_set ( J , 3 , 1 , atom99 );
gsl_matrix_set ( J , 3 , 4 , atom61 );
gsl_matrix_set ( J , 3 , 5 , atom64 );
gsl_matrix_set ( J , 4 , 0 , atom100 );
gsl_matrix_set ( J , 4 , 1 , atom101 );
gsl_matrix_set ( J , 4 , 4 , -atom64 );
gsl_matrix_set ( J , 4 , 5 , atom61 );
return J;
}
