#include <stdio.h>
#include <gsl/gsl_linalg.h>

void vector_printf(gsl_vector * Qv)
{
int i,j, error;

  for (i = 0; i < Qv->size; i++)
    {
      printf ("%.14g\n", gsl_vector_get (Qv, i));
    }
}

void permutation_printf(gsl_permutation * p)
{
size_t i,j;

  for (i = 0; i < p->size; i++)
    {
      printf ("\t%d", gsl_permutation_get (p, i));
    }
printf ("\n");
}


void matrix_printf(gsl_matrix * Jv)
{
int i,j;
  for (i = 0; i < Jv->size1; i++)
   {
    for (j = 0; j < Jv->size2; j++)
     {
      printf ("%.14g\t", 
              gsl_matrix_get (Jv, i, j));
     }
    printf ("\n");
   }
}
