//----------Q.c lib3D_MEC expoted-----------

//For increased velocity use GSL HAVE_INLINE and GSL_RANGE_CHECK_OFF preprocesor directive to compile:

// gcc -DHAVE_INLINE = 1 -DGSL_RANGE_CHECK_OFF = 1 ... ---

#include <stdio.h>
#include <gsl/gsl_vector.h>
#include "var_def.h"
#include "gen_coord_vect_def.h"
#include "gen_vel_vect_def.h"
#include "gen_accel_vect_def.h"
#include "unknowns_vect_def.h"
#include <math.h>
#define x gsl_vector_get ( q , 0 )
#define theta gsl_vector_get ( q , 1 )
#define dx gsl_vector_get ( dq , 0 )
#define dtheta gsl_vector_get ( dq , 1 )
#define ddx gsl_vector_get ( ddq , 0 )
#define ddtheta gsl_vector_get ( ddq , 1 )
#define Fgby gsl_vector_get ( unknowns , 0 )
#define Fgbz gsl_vector_get ( unknowns , 1 )
#define Mgbx gsl_vector_get ( unknowns , 2 )
#define Mgby gsl_vector_get ( unknowns , 3 )
#define Mgbz gsl_vector_get ( unknowns , 4 )
#define Fbpx gsl_vector_get ( unknowns , 5 )
#define Fbpy gsl_vector_get ( unknowns , 6 )
#define Fbpz gsl_vector_get ( unknowns , 7 )
#define Mbpx gsl_vector_get ( unknowns , 8 )
#define Mbpz gsl_vector_get ( unknowns , 9 )
extern double atom0;
extern double atom2;
extern double atom4;
extern double atom5;
extern double atom6;
extern double atom11;
extern double atom12;
extern double atom13;
extern double atom14;
extern double atom15;
extern double atom30;
extern double atom46;
extern double atom47;
extern double atom48;
extern double atom52;
extern double atom1;
extern double atom9;
extern double atom16;
extern double atom17;
extern double atom18;
extern double atom31;
extern double atom32;
extern double atom49;
extern double atom53;
gsl_vector * Phi = NULL;
gsl_vector * Q ()
{
size_t n_comp = 12;
if ( Phi == NULL )
 {
    Phi = gsl_vector_alloc ( n_comp );
/*constant*/ atom0 = -mblock*g;
/*constant*/ atom1 = -mpendulum*g;
gsl_vector_set ( Phi , 0 , 0.0 );
gsl_vector_set ( Phi , 1 , 0.0 );
gsl_vector_set ( Phi , 2 , -atom0 );
gsl_vector_set ( Phi , 3 , 0.0 );
gsl_vector_set ( Phi , 4 , 0.0 );
gsl_vector_set ( Phi , 5 , 0.0 );
gsl_vector_set ( Phi , 7 , 0.0 );
gsl_vector_set ( Phi , 9 , 0.0 );
gsl_vector_set ( Phi , 10 , 0.0 );
gsl_vector_set ( Phi , 11 , 0.0 );
 }
 atom2 = cos(-theta);
 atom4 = sin(-theta);
 atom5 = -atom4*l;
 atom6 = -l*atom2;
 atom11 = dtheta*atom5;
 atom12 = -atom6*ddtheta;
 atom13 = -dtheta*atom11;
 atom14 = atom12+atom13;
 atom15 = atom14+ddx;
 atom30 = -mpendulum*atom15;
 atom46 = -mpendulum*ddx;
 atom47 = -atom12*mpendulum;
 atom48 = atom47+atom46;
 atom52 = -atom48+atom30;
 atom9 = -dtheta*atom6;
 atom16 = ddtheta*atom5;
 atom17 = dtheta*atom9;
 atom18 = atom17+atom16;
 atom31 = -atom18*mpendulum;
 atom32 = atom1+atom31;
 atom49 = -mpendulum*atom16;
 atom53 = atom32-atom49;
gsl_vector_set ( Phi , 6 , -atom52 );
gsl_vector_set ( Phi , 8 , -atom53 );
return Phi;
}
