#include "Frame.h"
#include "System.h"
#include "Globals.h"

using std::string;


/*
General Frame's constructor
*/
Frame::Frame (  ){
	name = "";
	point = NULL;
	base = NULL;
}


/*
Constructor with name , Point and Base
*/
Frame::Frame ( string name , Point* point , Base* base ){
	this-> name = name;
	this-> point = point;
	this-> base = base;
}


/*
Return the Point of this Frame
*/
Point * Frame::get_Point ( void ) {
	return point;
}


/*
Return the Base of this Frame
*/
Base * Frame::get_Base ( void ) {
	return base;
}


/*
Return the Name of this Frame
*/
string Frame::get_name ( void ) {
	return name;
}


/*
Put the Point of this Frame
*/
void Frame::set_Point ( Point * new_point ) {
	point = new_point;
}


/*
Put the Base of this Frame
*/
void Frame::set_Base ( Base * new_base ) {
	base = new_base;
}


/*
Put the name of this Frame
*/
void Frame::set_name ( string new_name ){
	name = new_name;
}


/*
Destructor
*/
Frame::~Frame ( void ) {}

