#ifndef FRAME_H
#define FRAME_H

#include "Base.h"
#include "Point.h"
class System;

using std::string;

	class Frame {

		//Atributes

		string name;
		Point* point;
		Base* base;

	public:

		//Constructors

		Frame ( void );
		Frame ( string name , Point * point , Base * base );

		//Access methods

		Point * get_Point ( void );
		Base * get_Base ( void );
		string get_name ( void );
		void set_Base ( Base * new_base );
		void set_Point ( Point * new_point );
		void set_name ( string new_name );

		//Destructor

		~Frame ( void );
	};

#endif // FRAME_H
